using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;

namespace SampleGame
{
    /// <summary>
    /// ͊Ǘ
    /// </summary>
    public class InputManager
    {
        /// <summary>͏s܂</summary>
        public void Execute()
        {
            // L[{[h͏s܂
            ProcessInputKeyboard();

            // ͂ꍇ̓Q[pbh̓͂mF܂
            if (Global.m_controller.m_keyStatus == 0)
            {
                // Q[pbh͏s܂
                ProcessInputGamePad();
            }
        }

        /// <summary>L[{[h͏s܂</summary>
        /// <remarks>͌ʂ Controller NXɐݒ肳܂</remarks>
        protected void ProcessInputKeyboard()
        {
            // xQ[pbhNA܂
            Global.m_controller.Reset();

            KeyboardState ks = Keyboard.GetState();

            #region ̏
            #region L[
            if (ks.IsKeyDown(Keys.Up) == true)
            {
                if ((Global.m_controller.m_keyStatus & Controller.LEFT_UP) == 0)
                {
                    Global.m_controller.m_keyStatus |= Controller.LEFT_UP;
                    Global.m_controller.m_keyStatus &= ~Controller.LEFT_DOWN;
                }
            }
            else if (ks.IsKeyDown(Keys.Down) == true)
            {
                if ((Global.m_controller.m_keyStatus & Controller.LEFT_DOWN) == 0)
                {
                    Global.m_controller.m_keyStatus |= Controller.LEFT_DOWN;
                    Global.m_controller.m_keyStatus &= ~Controller.LEFT_UP;
                }
            }
            if (ks.IsKeyDown(Keys.Right) == true)
            {
                if ((Global.m_controller.m_keyStatus & Controller.LEFT_RIGHT) == 0)
                {
                    Global.m_controller.m_keyStatus |= Controller.LEFT_RIGHT;
                    Global.m_controller.m_keyStatus &= ~Controller.LEFT_LEFT;
                }
            }
            else if (ks.IsKeyDown(Keys.Left) == true)
            {
                if ((Global.m_controller.m_keyStatus & Controller.LEFT_LEFT) == 0)
                {
                    Global.m_controller.m_keyStatus |= Controller.LEFT_LEFT;
                    Global.m_controller.m_keyStatus &= ~Controller.LEFT_RIGHT;
                }
            }
            #endregion

            #region JL[
            // 
            if (ks.IsKeyDown(Keys.NumPad8) == true)
            {
                if ((Global.m_controller.m_keyStatus & Controller.RIGHT_UP) == 0)
                {
                    Global.m_controller.m_keyStatus |= Controller.RIGHT_UP;
                    Global.m_controller.m_keyStatus &= ~Controller.RIGHT_DOWN;
                }
            }
            // 
            if (ks.IsKeyDown(Keys.NumPad2) == true)
            {
                if ((Global.m_controller.m_keyStatus & Controller.RIGHT_DOWN) == 0)
                {
                    Global.m_controller.m_keyStatus |= Controller.RIGHT_DOWN;
                    Global.m_controller.m_keyStatus &= ~Controller.RIGHT_UP;
                }
            }
            // E
            if (ks.IsKeyDown(Keys.NumPad6) == true)
            {
                if ((Global.m_controller.m_keyStatus & Controller.RIGHT_RIGHT) == 0)
                {
                    Global.m_controller.m_keyStatus |= Controller.RIGHT_RIGHT;
                    Global.m_controller.m_keyStatus &= ~Controller.RIGHT_LEFT;
                }
            }
            // 
            if (ks.IsKeyDown(Keys.NumPad4) == true)
            {
                if ((Global.m_controller.m_keyStatus & Controller.RIGHT_LEFT) == 0)
                {
                    Global.m_controller.m_keyStatus |= Controller.RIGHT_LEFT;
                    Global.m_controller.m_keyStatus &= ~Controller.RIGHT_RIGHT;
                }
            }
            #endregion

            #region {^
            // X^[g
            if (
                (ks.IsKeyDown(Keys.Q) == true) ||
                (ks.IsKeyDown(Keys.Enter) == true)
            )
            {
                if ((Global.m_controller.m_keyStatus & Controller.START) == 0)
                {
                    Global.m_controller.m_keyStatus |= Controller.START;
                }
            }
            // ZNg
            if (ks.IsKeyDown(Keys.W) == true)
            {
                if ((Global.m_controller.m_keyStatus & Controller.SELECT) == 0)
                {
                    Global.m_controller.m_keyStatus |= Controller.SELECT;
                }
            }
            // U 1{^
            if (ks.IsKeyDown(Keys.Z) == true)
            {
                if ((Global.m_controller.m_keyStatus & Controller.BUTTON_ATTACK1) == 0)
                {
                    Global.m_controller.m_keyStatus |= Controller.BUTTON_ATTACK1;
                }
            }
            // U 2{^
            if (ks.IsKeyDown(Keys.C) == true)
            {
                if ((Global.m_controller.m_keyStatus & Controller.BUTTON_ATTACK2) == 0)
                {
                    Global.m_controller.m_keyStatus |= Controller.BUTTON_ATTACK2;
                }
            }
            #endregion
            #endregion

            #region ㎞̏
            #region L[
            if (ks.IsKeyUp(Keys.Up) == true)
            {
                Global.m_controller.m_keyStatus &= ~Controller.LEFT_UP;
            }
            if (ks.IsKeyUp(Keys.Down) == true)
            {
                Global.m_controller.m_keyStatus &= ~Controller.LEFT_DOWN;
            }
            if (ks.IsKeyUp(Keys.Right) == true)
            {
                Global.m_controller.m_keyStatus &= ~Controller.LEFT_RIGHT;
            }
            if (ks.IsKeyUp(Keys.Left) == true)
            {
                Global.m_controller.m_keyStatus &= ~Controller.LEFT_LEFT;
            }
            #endregion

            #region JL[
            if (ks.IsKeyUp(Keys.NumPad8) == true)
            {
                Global.m_controller.m_keyStatus &= ~Controller.RIGHT_UP;
            }
            if (ks.IsKeyUp(Keys.NumPad2) == true)
            {
                Global.m_controller.m_keyStatus &= ~Controller.RIGHT_DOWN;
            }
            if (ks.IsKeyUp(Keys.NumPad6) == true)
            {
                Global.m_controller.m_keyStatus &= ~Controller.RIGHT_RIGHT;
            }
            if (ks.IsKeyUp(Keys.NumPad4) == true)
            {
                Global.m_controller.m_keyStatus &= ~Controller.RIGHT_LEFT;
            }
            #endregion

            #region {^
            // X^[g
            if (
                (ks.IsKeyUp(Keys.Q) == true) &&
                (ks.IsKeyUp(Keys.Enter) == true)
            )
            {
                Global.m_controller.m_keyStatus &= ~Controller.START;
            }
            // ZNg
            if (ks.IsKeyUp(Keys.W) == true)
            {
                Global.m_controller.m_keyStatus &= ~Controller.SELECT;
            }
            // U 1 {^
            if (ks.IsKeyUp(Keys.Z) == true)
            {
                Global.m_controller.m_keyStatus &= ~Controller.BUTTON_ATTACK1;
            }
            // U 2 {^
            if (ks.IsKeyUp(Keys.C) == true)
            {
                Global.m_controller.m_keyStatus &= ~Controller.BUTTON_ATTACK2;
            }
            #endregion
            #endregion

            #region D/A ϊ
            // @ړ̃fW^͂AiOɕϊ܂
            if ((Global.m_controller.m_keyStatus & Controller.LEFT_DIRECT_ON) != 0)
            {
                // 
                if ((Global.m_controller.m_keyStatus & Controller.LEFT_UP) != 0)
                {
                    Global.m_controller.m_padLeftStatus.Y = 1;
                }
                // 
                if ((Global.m_controller.m_keyStatus & Controller.LEFT_DOWN) != 0)
                {
                    Global.m_controller.m_padLeftStatus.Y = -1;
                }
                // 
                if ((Global.m_controller.m_keyStatus & Controller.LEFT_LEFT) != 0)
                {
                    Global.m_controller.m_padLeftStatus.X = -1;
                }
                // E
                if ((Global.m_controller.m_keyStatus & Controller.LEFT_RIGHT) != 0)
                {
                    Global.m_controller.m_padLeftStatus.X = 1;
                }
            }

            // Jړ̃fW^͂AiOɕϊ܂
            if ((Global.m_controller.m_keyStatus & Controller.RIGHT_DIRECT_ON) != 0)
            {
                // 
                if ((Global.m_controller.m_keyStatus & Controller.RIGHT_UP) != 0)
                {
                    Global.m_controller.m_padRightStatus.Y = 1;
                }
                // 
                if ((Global.m_controller.m_keyStatus & Controller.RIGHT_DOWN) != 0)
                {
                    Global.m_controller.m_padRightStatus.Y = -1;
                }
                // 
                if ((Global.m_controller.m_keyStatus & Controller.RIGHT_LEFT) != 0)
                {
                    Global.m_controller.m_padRightStatus.X = -1;
                }
                // E
                if ((Global.m_controller.m_keyStatus & Controller.RIGHT_RIGHT) != 0)
                {
                    Global.m_controller.m_padRightStatus.X = 1;
                }
            }
            #endregion
        }

        /// <summary>Q[pbh͏s܂</summary>
        /// <remarks>͌ʂ Controller NXɐݒ肳܂</remarks>
        protected void ProcessInputGamePad()
        {
            GamePadState status = GamePad.GetState(PlayerIndex.One);

            // XeBbN
            Global.m_controller.m_padLeftStatus = status.ThumbSticks.Left;
            // EXeBbN
            Global.m_controller.m_padRightStatus = status.ThumbSticks.Right;

            // X^[g{^
            if (status.Buttons.Start == ButtonState.Pressed)
            {
                if ((Global.m_controller.m_keyStatus & Controller.START) == 0)
                {
                    Global.m_controller.m_keyStatus |= Controller.START;
                }
            }
            // X^[g{^
            if (status.Buttons.Start == ButtonState.Released)
            {
                Global.m_controller.m_keyStatus &= ~Controller.START;
            }

            // {^ A 
            if (status.Buttons.A == ButtonState.Pressed)
            {
            }
            // {^ A 
            if (status.Buttons.A == ButtonState.Released)
            {
            }

            // {^ X 
            if (status.Buttons.X == ButtonState.Pressed)
            {
                // U 1 {^
                if ((Global.m_controller.m_keyStatus & Controller.BUTTON_ATTACK1) == 0)
                {
                    Global.m_controller.m_keyStatus |= Controller.BUTTON_ATTACK1;
                }
            }
            // {^ X 
            if (status.Buttons.X == ButtonState.Released)
            {
                // U 1 {^
                Global.m_controller.m_keyStatus &= ~Controller.BUTTON_ATTACK1;
            }

            // {^ B 
            if (status.Buttons.B == ButtonState.Pressed)
            {
                // U 2 {^
                if ((Global.m_controller.m_keyStatus & Controller.BUTTON_ATTACK2) == 0)
                {
                    Global.m_controller.m_keyStatus |= Controller.BUTTON_ATTACK2;
                }
            }
            // {^ B 
            if (status.Buttons.B == ButtonState.Released)
            {
                // U 2 {^
                Global.m_controller.m_keyStatus &= ~Controller.BUTTON_ATTACK2;
            }

            // {^ Y 
            if (status.Buttons.Y == ButtonState.Pressed)
            {
            }
            // {^ Y 
            if (status.Buttons.Y == ButtonState.Released)
            {
            }

            // {^gK[
            if (status.Triggers.Left != 0)
            {
            }
            // {^gK[
            if (status.Triggers.Left == 0)
            {
            }

            // {^EgK[
            if (status.Triggers.Right != 0)
            {
            }
            // {^gK[
            if (status.Triggers.Right == 0)
            {
            }
        }
    }
}
